<?php
$migration = new Clickwhale_Migration();
do_action( 'clickwhale_admin_banner' );
?>

<div class="wrap">
    <h1 class="wp-heading-inline"><?php _e( 'Tools', 'clickwhale' ); ?></h1>
	<?php settings_errors(); ?>

	<?php $active_tab = isset( $_GET['tab'] ) ? sanitize_text_field( $_GET['tab'] ) : 'migration_options'; ?>

    <h2 class="nav-tab-wrapper">
        <a href="?page=clickwhale-tools&tab=migration_options"
           class="nav-tab <?php echo $active_tab == 'migration_options' ? 'nav-tab-active' : ''; ?>"><?php _e( 'Migration', 'clickwhale' ); ?></a>
        <a href="?page=clickwhale-tools&tab=reset_options"
           class="nav-tab <?php echo $active_tab == 'reset_options' ? 'nav-tab-active' : ''; ?>"><?php _e( 'Reset', 'clickwhale' ); ?></a>
    </h2>

    <form method="post" action="options.php">
		<?php

		if ( $active_tab == 'migration_options' ) {
			$show_settings = false;

			foreach ( $migration->available_migrations() as $item ) {
				if ( $migration->check_active( $item['path'] ) ) {
					$show_settings = true;
					?>

                    <div class="clickwhale-migration-section clickwhale-migration-section-<?php echo $item['slug'] ?>">
						<?php
						settings_fields( 'clickwhale_tools_' . $item['slug'] . '_migration_options' );
						do_settings_sections( 'clickwhale_tools_' . $item['slug'] . '_migration_options' );
						?>
                        <div id="clickwhale-tools-migration-submit">
                            <button type="button"
                                    class="button button_start_migrate"
                                    data-migration="<?php echo esc_attr( $item['slug'] ) ?>"><?php _e( 'Start migration', 'clickwhale' ) ?></button>
                            <span class="spinner"></span>
                        </div>
                        <div class="results"></div>
                    </div>
					<?php
				}
			}

			if ( $show_settings ) {
				?>
                <div id="clickwhale-tools-migration-reset">
                    <button class="button button-primary button_reset_migrate"
                            type="button"><?php _e( 'Set default options and clear cache', 'clickwhale' ) ?></button>
                    <span class="results"></span>
                    <span class="spinner"></span>
                </div>
			<?php } else { ?>
                <h3 class=""><?php _e( 'No data to migrate! ', 'clickwhale' ); ?></h3>
                <p><?php _e( 'You do not have active plugins from which we can transfer data.', 'clickwhale' ); ?></p>
			<?php }
		}
		if ( $active_tab == 'reset_options' ) {
			?>
            <div id="clickwhale-tools-reset">
	            <?php
	            settings_fields( 'clickwhale_tools_reset_settings' );
	            do_settings_sections( 'clickwhale_tools_reset_settings' );
	            ?>
                <p class="submit">
                    <button id="button-reset-settings" class="button button-primary"
                            type="button"><?php _e( 'Restore default settings', 'clickwhale' ) ?></button>
                    <span class="spinner"></span>
                    <span class="results"></span>
                </p>
                <hr>
				<?php
				settings_fields( 'clickwhale_tools_reset_db_settings' );
				do_settings_sections( 'clickwhale_tools_reset_db_settings' );
				?>
                <p class="submit">
                    <button id="button-reset-db" class="button button-primary"
                            type="button"><?php _e( 'Delete all plugin data now', 'clickwhale' ) ?></button>
                    <span class="spinner"></span>
                    <span class="results"></span>
                </p>
                <hr>
				<?php
				settings_fields( 'clickwhale_tools_reset_stats_settings' );
				do_settings_sections( 'clickwhale_tools_reset_stats_settings' );
				?>
                <p class="submit">
                    <button id="button-reset-stats" class="button button-primary"
                            type="button"><?php _e( 'Reset all tracking data now', 'clickwhale' ) ?></button>
                    <span class="spinner"></span>
                    <span class="results"></span>
                </p>

            </div>
			<?php
		}
		?>
    </form>
</div>